"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AES256 = void 0;
const buffer_1 = __importDefault(require("scrypt-js/thirdparty/buffer"));
const AES = __importStar(require("aes-js"));
const Translators_1 = require("./Translators");
const scrypt = __importStar(require("scrypt-js"));
class AES256 {
    async decrypt(notepad, passkey) {
        const cipherText = notepad.sections;
        const key = await this.keyGenerator(passkey);
        const controller = new AES.ModeOfOperation.ctr(key);
        const plainText = AES.utils.utf8.fromBytes(controller.decrypt(AES.utils.hex.toBytes(cipherText)));
        notepad = Object.assign(Object.assign({}, notepad), { sections: JSON.parse(plainText) });
        return Translators_1.Translators.Json.toNotepadFromNotepad(notepad);
    }
    async encrypt(notepad, passkey) {
        const plainText = AES256.stringifyNotepadObj(notepad.sections);
        const key = await this.keyGenerator(passkey);
        const controller = new AES.ModeOfOperation.ctr(key);
        const cipherText = AES.utils.hex.fromBytes(controller.encrypt(AES.utils.utf8.toBytes(plainText)));
        return Object.assign(Object.assign({}, notepad), { sections: cipherText });
    }
    keyGenerator(passkey) {
        passkey = passkey.normalize('NFKC');
        const passkeyBuff = new buffer_1.default.SlowBuffer(passkey);
        return scrypt.scrypt(passkeyBuff, new buffer_1.default.SlowBuffer(''), 1024, 8, 1, 32);
    }
    static stringifyNotepadObj(obj) {
        return JSON.stringify(obj, (key, value) => {
            return (key === 'parent') ? undefined : value;
        });
    }
}
exports.AES256 = AES256;
//# sourceMappingURL=AES256.js.map