"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AES256GZ = void 0;
const AES256_1 = require("./AES256");
const Translators_1 = require("./Translators");
const AES = __importStar(require("aes-js"));
const lz_string_1 = require("lz-string");
class AES256GZ extends AES256_1.AES256 {
    async decrypt(notepad, passkey) {
        const cipherText = notepad.sections;
        const key = await this.keyGenerator(passkey);
        const controller = new AES.ModeOfOperation.ctr(key);
        const plainTextGz = AES.utils.utf8.fromBytes(controller.decrypt(AES.utils.hex.toBytes(cipherText)));
        const plainText = lz_string_1.decompressFromUTF16(plainTextGz);
        if (!plainText)
            throw new Error(`The notebook couldn't be decrypted`);
        try {
            notepad = Object.assign(Object.assign({}, notepad), { sections: JSON.parse(plainText) });
        }
        catch (e) {
            throw new Error(`The notebook couldn't be decrypted`);
        }
        return Translators_1.Translators.Json.toNotepadFromNotepad(notepad);
    }
    async encrypt(notepad, passkey) {
        const plainText = AES256_1.AES256.stringifyNotepadObj(notepad.sections);
        const plainTextGz = lz_string_1.compressToUTF16(plainText);
        const key = await this.keyGenerator(passkey);
        const controller = new AES.ModeOfOperation.ctr(key);
        const cipherText = AES.utils.hex.fromBytes(controller.encrypt(AES.utils.utf8.toBytes(plainTextGz)));
        return Object.assign(Object.assign({}, notepad), { sections: cipherText });
    }
}
exports.AES256GZ = AES256GZ;
//# sourceMappingURL=AES256GZ.js.map