import { Parent } from './interfaces';
import { Note } from './index';
export declare abstract class NPXObject {
    parent: Parent | string | undefined;
    readonly title: string;
    readonly internalRef: string;
    protected constructor(title: string, internalRef?: string, parent?: Parent | string);
    abstract search(query: string): Note[];
    /**
     * @returns {Promise<any>} A version of the object that the XML generator can parse
     */
    abstract toXmlObject(): any;
    protected generateGuid(): string;
    /**
     * @param {string} str
     * @returns {string} The string without certain values that could cause parsing issues in the future
     */
    protected clean(str: string): string;
}
