"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.NPXObject = void 0;
class NPXObject {
    constructor(title, internalRef, parent) {
        this.title = this.clean(title);
        this.internalRef = internalRef || this.generateGuid();
        this.parent = parent;
    }
    generateGuid() {
        function s4() {
            return Math.floor((1 + Math.random()) * 0x10000).toString(16).substring(1);
        }
        return s4() + s4() + '-' + s4() + '-' + s4() + '-' + s4() + '-' + s4() + s4() + s4();
    }
    /**
     * @param {string} str
     * @returns {string} The string without certain values that could cause parsing issues in the future
     */
    clean(str) {
        return str.replace(/<[^>]*>/, "");
    }
}
exports.NPXObject = NPXObject;
//# sourceMappingURL=NPXObject.js.map