import { Note } from './index';
export declare class Trie {
    static buildTrie(notes: {
        [internalRef: string]: Note;
    }, date?: Date): Trie;
    static shouldReindex(trie: Trie, lastModified: Date, numberOfNotes: number): boolean;
    static add(trie: Trie, key: string, ref: string): void;
    static search(trie: Trie, query: string): string[];
    private _size;
    private readonly root;
    private readonly lastModified;
    private readonly hashtags;
    constructor(lastModified?: Date);
    get size(): number;
    get availableHashtags(): string[];
    /**
     * @deprecated Use static methods instead
     */
    shouldReindex(lastModified: Date, numberOfNotes: number): boolean;
    /**
     * @deprecated Use static methods instead
     */
    add(key: string, ref: string): void;
    /**
     * @deprecated Use static methods instead
     */
    search(query: string): string[];
}
