"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.encrypt = exports.decrypt = void 0;
const AES256_1 = require("./AES256");
const AES256GZ_1 = require("./AES256GZ");
async function decrypt(notepad, passkey) {
    return getMethod(notepad).decrypt(notepad, passkey);
}
exports.decrypt = decrypt;
async function encrypt(notepad, passkey) {
    return getMethod(notepad).encrypt(notepad, passkey);
}
exports.encrypt = encrypt;
function getMethod(notepad) {
    if (!notepad.crypto)
        throw new Error(`This notepad isn't encrypted.`);
    const method = methods[notepad.crypto];
    if (!method)
        throw new Error(`No such method: '${notepad.crypto}' exists.`);
    return method;
}
const methods = {
    'AES-256': new AES256_1.AES256(),
    'AES-256-GZ': new AES256GZ_1.AES256GZ()
};
//# sourceMappingURL=crypto.js.map